import de.bezier.data.sql.*;

MySQL msql;
String DL = ",";
int bound = 35;
String [] year= {
  "2006", "2007", "2008", "2009", "2010", "2011", "2012", "2013"
};
int [] book= new int[84];
int [] jcbook=new int[84];

void setup() {

  size(970, 640);
  colorMode(HSB, 360, 100, 100);

  msql= new MySQL ( this, "tango.mat.ucsb.edu", "spl1", "mat259", "V1sual1zat1on" );
  if (msql.connect()) {
    String TheQuery = "select year(o),month(o),SUM(CASE WHEN kind=\"acbk\" THEN 1 ELSE 0 END)as book,SUM(CASE WHEN kind=\"jcbk\" THEN 1 ELSE 0 END)as jcbook from title, activity, kind where title like \"%photogra%\" AND activity.bib=title.bib AND activity.item=kind.item AND year(o)>2005 AND year(o)<2013 group by month(o), year(o) order by year(o),month(o);";
    println(TheQuery);
    msql.query( TheQuery);
    msql.next();
    int count = 0;
    while ( msql.next () ) {
      println( msql.getString(1) + DL + msql.getString(2)+ DL + msql.getString(3)+ DL + msql.getString(4) );
      book[count+1]=msql.getInt(3);
      jcbook[count+1]=msql.getInt(4);
      count++;
    }
  }
  else {
    println ("connection failed ");
  }
  for (int i=0; i<84; i++) {
    println(book[i]);
  }
}


void draw() {

  int [] mbook= new int[84];
  int [] mjcbook=new int[84];
  int [] colbook= new int[84];
  int [] coljcbook=new int[84];
  int [] monthPostion=new int[84];
  int [] numPostion=new int[84];
  book[0]=857;
  jcbook[0]=61;

  for (int i=0; i<84; i++) {

    mbook[i]=round(map(book[i], 1, 1300, 1, 400));
    mjcbook[i]=round(map(jcbook[i], 1, 1300, 1, 400));
    colbook[i]=round(map(book[i], 700, 1138, 1, 60));
    coljcbook[i]=round(map(jcbook[i], 30, 81, 1, 30));
  }



  background(290, 0, 0);
  noStroke();

  //year label
  for (int i= 0;i<7;i++) {
    //fill(200, 61, 56);
    //rect(bound+130*i, 575, 120, 35);
    fill(290, 0, 0);
    textSize(18);
    textAlign(LEFT, CENTER);
    text(year[i], 39+130*i, 600);

    fill(0, 0, 100);
    textSize(18);
    textAlign(LEFT, CENTER);
    text(year[i], 37+130*i, 600);
    
    
    
  }
   
  //numbers of book

  for (int i= 0;i<84;i++) {
    //stroke(290, 0, 0);
    fill(322, 57, 40+colbook[i]);
    rect(bound+10*i+10*(i/12), 570-mbook[i], 10, mbook[i]);
    monthPostion[i]=bound+10*i+10*(i/12);
  }
  //numbers of jcbook

  for (int i= 0;i<84;i++) {
    //stroke(290, 0, 0);  
    fill(28, 40, 70+coljcbook[i]);
    rect(bound+10*i+10*(i/12), 570-mbook[i]-mjcbook[i], 10, mjcbook[i]);
    numPostion[i]=570-mbook[i]-mjcbook[i];
  }


  //title
  fill(0, 0, 100);
  textSize(18);
  textAlign(LEFT, CENTER);
  text("NUMBERS OF CHECKOUTS ABOUT PHOTOGRAPHIC", 40, 30);
  text("BOOKS EACH MONTHS DURING 2006-2012", 40, 50);

  //content
  fill(322, 57, 72);
  rect(95, 90, 30, 10);
  fill(28, 40, 100);
  rect(95, 110, 30, 10);
  fill(0, 0, 100);
  textAlign(LEFT, CENTER);
  text("acbk", 40, 95);
  text(" jcbk", 40, 115);

  //show data 
  for (int i=0; i<84; i++) {
    if ( mouseY>numPostion[i] && mouseY<530 && mouseX>monthPostion[i]&&mouseX<monthPostion[i]+10) {
      int numpos;
      if (i<41) numpos=10;
      else numpos=-190;
      //noStroke();
      fill(351, 33, 86);
      //rect(monthPostion[i]+numpos, numPostion[i]-70, 190, 40);

      fill(0, 0, 100);
      textAlign(CENTER, CENTER);
      text("acbk: "+book[i]+"; jcbk: "+jcbook[i], monthPostion[i]+numpos+95, numPostion[i]-150*(numPostion[i])/500);


      //refill
      fill(328, 70, 100);
      rect(bound+10*i+10*(i/12), 570-mbook[i], 10, mbook[i]);
      fill(30, 70, 100);
      rect(bound+10*i+10*(i/12), 570-mbook[i]-mjcbook[i], 10, mjcbook[i]);
    }
  }
  
  //month scale
  for (int i= 0;i<84;i++) {
    stroke(0,0,100);
    line(39+10*i+10*(i/12),577,39+10*i+10*(i/12),582);
  }
}

